class Slider {
    constructor() {
        this.images = document.getElementsByClassName('imgslider');
        this.currentIndex = 0;//Commencer toujours à 0
    }

    play() {
        document.getElementById("play").style.display = "none";
        document.getElementById("pause").style.display = "block";
    }

    pause() {
        clearInterval(this.interval);
        document.getElementById("play").style.display = "block";
        document.getElementById("pause").style.display = "none";
    }

    suivante() {
        //la fonction suivante est utilisé lorsqu'on passe à la diapositive suivante avec les touches manuelles ou touches du clavierche
        this.images[this.currentIndex].style.display = 'none';
        if (this.currentIndex < this.images.length - 1) {
            //signifier la longueur total du tableau
            this.currentIndex++;
        } else {
            this.currentIndex = 0;
        }
        this.images[this.currentIndex].style.display = 'block';
        //affiche moi la position currentIndex = 0
    }

    precedente() {
        this.images[this.currentIndex].style.display = 'none';
        if (this.currentIndex > 0) {
            this.currentIndex--;
        } else {
            this.currentIndex = this.images.length - 1;
        }
        this.images[this.currentIndex].style.display = 'block';
    }
}

var sliderobjet = new Slider();
// sliderobjet.play();
sliderobjet.interval = setInterval(function () { sliderobjet.suivante() }, 5000);

//Evenements boutons
document.getElementById("diaposuivante").addEventListener("click", function () {
    sliderobjet.suivante();
    sliderobjet.pause();
});
document.getElementById("diapoprécédente").addEventListener("click", function () {
    sliderobjet.precedente();
    sliderobjet.pause();
});

document.getElementById("pause").addEventListener("click", function () {
    sliderobjet.pause();
});

document.getElementById("play").addEventListener("click", function () {
    sliderobjet.play();
    sliderobjet.interval = setInterval(function () { sliderobjet.suivante() }, 5000);
});