// FCN = Foncts_Core_Node
const CNF_HTTP = require('http');
const CNF_HTTP2 = require('http2');
const CNF_PATH = require('path');
const CNF_FS = require('fs');
const CNF_URL = require('url');
const CNF_NODEMAILER = require('nodemailer');
require('remedial');

const Fx = require('./functions.js');
const nodemailer = require('./nodemailer.js')
const { send } = require('process');
const { match } = require('assert');

let serverWeb;

const listport = [20, 21, 80, 8080, 443];
const listhost = ["localhost","0.0.0.0"];
let portWeb = listport[2];
let host = listhost[1];

serverWeb = CNF_HTTP.createServer((request, response) => {
    // Déclaration de constante à modifier pour adapter le serveur web
    const actualFolderTowork = "/PUBLIC";
    const parentFolderForHTMLFile = "/HTML5";
    const homePage = "/Accueil.html";
    const actualFileToStorageDataUser = "./dataUser.json";
    const errorPage404 = "/ERREUR/404.html";
    const arrayOfGoodKeyToVerifyUserKeys = ["Prenom", "Nom", "Email", "Telephone", "Message"];
    const actionAttributeForm1 = "/formContact";
    const responsePageform = "/Response_Form.html";
    const save = true;

    if (request.url.includes(actionAttributeForm1)){
        let arrayKeyValuesQS = [];
        let arrayInfosUser = [];
        // Extraction Query String Complete depuis URL
        // Les Actions éxécutées ici doivent nécéssité une QueryString.
        let StringURL = request.url
        let completeQS = StringURL.split("?");
        completeQS = completeQS[1];
        // Affichage Query String Complete
        //console.log(completeQS);
        
        // Vérification Présence du ou des Clé(s) au sein de la Query String saisie par l'utilisateur
        // Si plusieurs paramètres sont présents
        if (completeQS.includes('&')) { 
            // Pour chaque couple de clé/valeur : 
                // 1 : Effectué la séparation de ces deux éléments (Clé et Valeur)
                // 2 : Ajoute automatiquement (Fonction Split("")) le paramètre dans un tableau à l'index 0 et la valeur à l'index 1
                // 3 : Ajouter le tableau de clé/Valeur composant un paramètre dans un tableau de arrayInfosUser
                // Ajouter chaque paramètre et sa valeur associé dans un tableau
            arrayKeyValuesQS = completeQS.split("&");
            arrayKeyValuesQS.forEach(QS => {
                KeyAndValue = QS.split("=");
                arrayInfosUser.push(KeyAndValue);
            });
        }else{
            // Si un seul paramètre est dans la Querystring
            arrayKeyValuesQS.push(completeQS);
            arrayKeyValuesQS.forEach(QS => {
                KeyAndValue = QS.split("=");
                arrayInfosUser.push(KeyAndValue);
            });
        }

        // Affiche dans la console des Clés et valeur de l'URL saisie par l'utiilisateur : Ex : "[ [ 'Nom', 'Xxxxx' ] ]"
        // console.log(arrayInfosUser);

        // Contrôle de la présence de plusieurs paramamètres sont présents dans la QueryString 
        if (arrayInfosUser[0][0] == arrayOfGoodKeyToVerifyUserKeys [0] &&
            arrayInfosUser[1][0] == arrayOfGoodKeyToVerifyUserKeys [1] &&
            arrayInfosUser[2][0] == arrayOfGoodKeyToVerifyUserKeys [2] &&
            arrayInfosUser[3][0] == arrayOfGoodKeyToVerifyUserKeys [3] &&
            arrayInfosUser[4][0] == arrayOfGoodKeyToVerifyUserKeys [4])
            {
            // Début Traitement du formulaire
            let firstName;
            let lastName;
            firstName = Fx.fonctFormatString(arrayInfosUser[0][1]);
            // if (arrayInfosUser[0][1].match(/^([A-Z]|[a-z])+(\-|)+([A-Z]|[a-z])+/) && arrayInfosUser[0][1].match(/[^(!()!_$*€£`+=\/;?#)]/)){
                
            // }else{console.log("Erreur Prénom");}
            lastName = Fx.fonctFormatString(arrayInfosUser[1][1]);
            // if (arrayInfosUser[1][1].match(/^([A-Z]|[a-z])+(\-|)+([A-Z]|[a-z])+/)){
               
            // }else{console.log("Erreur Nom");}
            let mail = arrayInfosUser[2][1].replace("%40","@");
            let tel = Fx.fonctFormatPhoneNumber(arrayInfosUser[3][1]);
            let message = decodeURI(arrayInfosUser[4][1]);
            // console.log(arrayInfosUser);
            console.log(firstName, lastName, mail, tel, message);
            // Fin du Traitement du formulaire

            // Début Envoi Informations par E-mail
            // Ajout Infos Informations utilisateur formatées dans le template de l'e-mail de notification

            let templateFile = CNF_FS.readFileSync("./PUBLIC/HTML5/Email_Notification.html");
            let InfosUserMail = {};
            InfosUserMail["firstName"] = firstName;
            InfosUserMail["lastName"] = lastName;
            InfosUserMail["mail"] = mail;
            InfosUserMail["tel"] = tel;
            InfosUserMail["message"] = message;
            templateFile = templateFile.toString().supplant(InfosUserMail);
            // Propriétés permettant la construction du mail à envoyer et envoi
            // console.log(templateFile);
            let info = nodemailer.transporterTest.sendMail({
            from: 'alexissavreuxlecoeur@orange.fr', // sender address
            to: "alexissavreuxlecoeur@orange.fr", // list of receivers
            subject: "Notification de contact client", // Subject line
            attachments: [{
                filename: 'Logo_Vaunage_Construction_E-mail.png',
                path: './PUBLIC/IMG/Elements_Communs/Logo_Vaunage_Construction_E-mail.png',
                cid: 'LogoVCE-Mail' // Paste here same cid value as in the html image source
            }],
           
            text:   // plain text body
            `Bonjour M. Guzman,\n
            \n
            Vous trouverez ci joint les coordonées de contact d'un visiteur à recontacter :\n
            Nom : ${firstName}\n
            Prénom : ${lastName}\n
            E-mail : ${mail}\n
            Téléphone : ${tel}\n
            Message à transmettre : \"${message}\"\n\n
            Cordialement,\n
            Mme ou M. ${lastName}`, 
            html: templateFile,
            amp: templateFile
            });
            console.log("E-mail Envoyé");
            // // Fin Envoi Informations par E-mail

            // Début Envoi de la page de réponse spécifique après la validation du formulaire.
            filePath = actualFolderTowork + parentFolderForHTMLFile + responsePageform;
            //   console.log(filePath);
            extFile = CNF_PATH.extname(filePath).replace(".", "");
            // Controle lien pour chargement de Contact.html en réponse au formulaire
            // Chargement HTML5 Contact.html après click bouton formulaire
            Fx.fonctSendHTMLFile(response,filePath, 'text/' + extFile);
            // Fin Envoi de la page de réponse spécifique après la validation du formulaire.

            // Début Enregistrement des Donnés
            if (save == true){
                let contentFile;
                let dataReadyToWrite = [];
                let objectInfosUser = {};
                contentFile = CNF_FS.readFileSync(actualFileToStorageDataUser, "utf-8")
                //console.log(`ContentFile = "${ContentFile}"`);
                
                // Pour chaque couple de Clé / Valeur dans arrayInfosUser
                // Ajout Clé : Valeur à l'objetInfosUser
                arrayInfosUser.forEach(element => {
                    objectInfosUser[element[0]] = element[1];
                });
                    
                // Affichage des clés saisies par l'utilisateur sous forme d'object.
                // console.log(objectInfosUser);
                
                if (contentFile == ""){
                    // Ajout de l'objet envoyé à un tableau de stockage de données
                    dataReadyToWrite.push(objectInfosUser);
                    // Ecriture du tableau précédent au format JSON
                    dataReadyToWrite = JSON.stringify(dataReadyToWrite);
                    // console.log(DataReadyToWrite);
                    CNF_FS.writeFileSync(actualFileToStorageDataUser, dataReadyToWrite,"utf-8");
                }else{
                    let DataFromFile = JSON.parse(contentFile);
                    DataFromFile.push(objectInfosUser);
                    dataReadyToWrite = JSON.stringify(DataFromFile);
                    //console.log(DataFromFile);
                    CNF_FS.writeFileSync(actualFileToStorageDataUser, dataReadyToWrite,"utf-8");
                }
            }else{
                console.log("Pas de sauvegarde des données utilisateurs");
                // throw "Pas de sauvegarde des données utilisateurs";
            }
        }else{
            console.log("Les clés saisies sont absentes ou mal orthographiées");
            // throw "Les clés saisies sont absentes ou mal orthographiées"
        }
    }else{
        let filePath = actualFolderTowork + parentFolderForHTMLFile + (request.url == '/' || request.url == "/index.html" || request.url == homePage ? homePage : request.url);
        //console.log(filePath);
        extFile = CNF_PATH.extname(filePath).replace(".", "");
        switch (extFile) {
            case "html":
                if (filePath == actualFolderTowork + parentFolderForHTMLFile + homePage){
                    Fx.fonctSendHTMLFile(response,filePath, 'text/' + extFile);
                }else{
                    filePath = actualFolderTowork + parentFolderForHTMLFile + request.url;
                    Fx.fonctSendHTMLFile(response,filePath);
                }
                break;
            case "css":
                filePath = actualFolderTowork + request.url;
                Fx.fonctSendFile(response,filePath, 'text/' + extFile);
                break;
            case "png":
                filePath = actualFolderTowork + request.url;
                Fx.fonctSendFile(response,filePath, 'image/' + extFile);
                break;
            case "jpg":
            case "jpeg":
                filePath = actualFolderTowork + request.url;
                Fx.fonctSendFile(response, filePath, 'image/' + extFile);
                break;
            case "ico":
                filePath = actualFolderTowork + request.url;
                Fx.fonctSendFile(response, filePath, 'image/vnd.microsoft.icon');
                break;
            case "js":
                filePath = actualFolderTowork + request.url;
                Fx.fonctSendFile(response,filePath, 'application/x-javascript');
                break;
            default:
                Fx.fonctSendFile(response, actualFolderTowork + errorPage404, 'text/html', 404);
                break;
        }
    }
});

serverWeb.listen(portWeb, host, () => {
    console.log("Le serveur est connecté sur le " + host + ":" + portWeb + ".");
});